function [Mar,logz,bound]=MF_block(G,Y,u0,u)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%beta=0.85;  % damping
[n,K]=size(Y);
% Given cluster-label matrix Y \in R^{Nxk}
% for points in one cluster

% data structure needed:   Mar: singlten Marginal 
Mar=ones(2,n)*0.5;     %initialize singlten marginal
ss1 = normalise(rand(2,n),1);
Mar=ones(2,n).*ss1;

M=n/K;
label=cell(K,1);    % 0-1 label of each cluster
list=cell(K,1);     % list of ids of nodes in each cluster 
u0_sub=cell(K,1);
u_sub=cell(K,1);
G_sub=cell(K,1);
G_neighbor=cell(K,1);
Ls_s=cell(K,1);
Psi_s=cell(K,1);
x1=[-1; 1];
x1=[1; -1];

for k=1:K; 
  label{k}=zeros(n,1);  
  u_sub{k}=zeros(M,1); u_sub{k}=zeros(M,M); 
  G_sub{k}=zeros(M,M); G_neighbor{k}=zeros(M,n);
  Ls_s{k}=zeros(M,1);  Psi_s{k}=zeros(M,M); 
end


for k=1:K %---for each cluster

label{k}=Y(:,k);
M=sum(label{k});
list{k}=find(label{k}==1);  % list of ids of nodes in cluster 'k'

  u0_sub{k}=zeros(M,1); u_sub{k}=zeros(M,M); 
  G_sub{k}=zeros(M,M); G_neighbor{k}=zeros(M,n);
  
% adjacency matrix of each cluster
for i=1:M
  for j=1:M
    G_sub{k}(i,j)=G(list{k}(i),list{k}(j));
  end
  for l=1:n
    G_neighbor{k}(i,l)=(G(list{k}(i),l)~=0)&(length(find(list{k}==l))==0);
  end
end

% weights in the cluster
for i=1:M
  id=list{k}(i);
  u0_sub{k}(i)=(u(id,:).*G_neighbor{k}(i,:))*(Mar'*x1) + u0(id);
end
for i=1:M
  for j=1:M
    u_sub{k}(i,j)=u(list{k}(i),list{k}(j));
  end
end

% weight in GBP format:
Psi_s{k}=cell(M,M);
Ls_s{k}=cell(M,1);
for i=1:M
  Ls_s{k}{i}=[exp(u0_sub{k}(i));exp(-u0_sub{k}(i))];
  for j=1:M
    if G_sub{k}(i,j)~=0
      Psi_s{k}{i,j}=[exp(u_sub{k}(i,j)) exp(-u_sub{k}(i,j)); 
		     exp(-u_sub{k}(i,j)) exp(u_sub{k}(i,j))];
    end
  end
end

end % end proprocessing of each cluster


% run GMF

count = 0;
converge=0;
diff = Inf;
logZ=zeros(K,1);

%rand('seed',0);
ss1 = normalise(rand(2,n),1);
start=ones(2,n).*ss1;
%start=ones(2,n)*0.5;

while converge==0
  
  count=count+1;
  
  for k=1:K
  
    % up date GMFs of the current cluster
    for i=1:length(list{k})
      id=list{k}(i);
      u0_sub{k}(i)=(u(id,:).*G_neighbor{k}(i,:))*(Mar'*x1) + u0(id);
      %bumped_mf=(Mar'*x1*(1-beta)+start'*x1*beta);
      %u0_sub{k}(i)=(u(id,:).*G_neighbor{k}(i,:))*bumped_mf + u0(id);
      Ls_s{k}{i}=[exp(u0_sub{k}(i));exp(-u0_sub{k}(i))];
    end
    
    [belG_s,logZ(k)]=exactInference_new(G_sub{k},Ls_s{k},Psi_s{k});
    for i=1:length(list{k})
      Mar(:,list{k}(i))=belG_s(:,i);
    end % refresh marginals
    
    if count>1
      diff=Mar-old;
    end  
    old=Mar;
    start = Mar;
  
    zz=max(max(max(diff)))/n;
    if zz < 1e-10 | count>30;
      converge = 1;
    end
    
  end
 
end

logz=sum(logZ);
E=0; Eq=0;
for k=1:K
  for i=1:length(list{k})
    id=list{k}(i);
    E=E+(u(id,:).*G_neighbor{k}(i,:))*((Mar'*x1)*(Mar(:,id)'*x1));
    Eq=Eq+(u0_sub{k}(i)-u0(id))*(Mar(:,id)'*x1)*...
    (length(find(G_neighbor{k}(i,:)==1))~=0);
  end
end
%logz
%E
%Eq
bound=logz-Eq+(E/2)
%bound=logz+(Eq-E);
