function Q = purity (q, q1)

p1=purity1(q, q1); % similarity constraints
p2=purity2(q, q1); % disimilarity constraints
Q = (p1+p2)/2;

%K = length(q);
%ccc=0;
%for i=1:K
%  for j=i+1:K
%    ccc = ccc + ((q(i)==q(j))==(q1(i)==q1(j)));
%  end
%end
%Q = ccc/(0.5*K*(K-1));

%-----------------------------------------------
function Q = purity1(q, q1)
% q1 is the reference. propotional agreements on similarity constraints
K = length(q);
ccc=0; ccc1=0;
for i=1:K
  for j=i+1:K
    ccc = ccc + ((q(i)==q(j))==(q1(i)==q1(j)))*(q1(i)==q1(j));
    ccc1 = ccc1 + (q1(i)==q1(j));
  end
end
Q = ccc/ccc1;

%-----------------------------------------------
function Q = purity2(q, q1)
% q1 is the reference. propotional agreements on disimilarity constraints
K = length(q);
ccc=0; ccc1=0;
for i=1:K
  for j=i+1:K
    ccc = ccc + ((q(i)==q(j))==(q1(i)==q1(j)))*(q1(i)~=q1(j));
    ccc1 = ccc1 + (q1(i)~=q1(j));
  end
end
Q = ccc/ccc1;


